/* Author : Budirijanto Purnomo */
/* A and B alternating execution */

#include  <stdio.h>
#include  <stdlib.h>
#include  "mtuThread.h"
#define ITERATIONS 10

THREAD_t THREAD_A, THREAD_B;

void  A(int  ID)
{
  int i=0;
  while (i<ITERATIONS) 
  {                         
    write(1, "A ", 2);              /* print A              */
    if (++i%2 == 0)
    {
      write(1, "\n", 1);
      THREAD_RESUME(THREAD_B);
      THREAD_SUSPEND(THREAD_SELF());
    }
  }
  THREAD_EXIT();
}

void  B(int  ID)
{
  int i=0;
  while (i<ITERATIONS) 
  {                        
    write(1, "B ", 2);              /* print B            */
    if (++i%2 == 0)
    {
      write(1, "\n", 1);
      THREAD_RESUME(THREAD_A);
      THREAD_SUSPEND(THREAD_SELF());
    }
  }

  /* last pass before quit, need to resume A */
  THREAD_RESUME(THREAD_A);
  THREAD_EXIT();
}

/* ---------------------------------------------------------------- */
/*                        The main program                          */
/* ---------------------------------------------------------------- */
int main(int argc, char *argv[])
{
  THREAD_A = THREAD_CREATE(A, THREAD_SIZE, THREAD_SUSPENDED, 1, (char **) 0);
  THREAD_B = THREAD_CREATE(B, THREAD_SIZE, THREAD_NORMAL, 1, (char **) 0);

  THREAD_JOIN(THREAD_A);

  return 0;
}

